/*
 Copyright (c) 2010, The Barbarian Group
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted provided that
 the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and
	the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
	the following disclaimer in the documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
*/

#include "cinder/app/AppImplOF.h"
#include "cinder/app/App.h"
#include "ofMain.h"
#include <cstring>

using std::string;
using std::vector;
using std::pair;

namespace cinder { namespace app {

void AppImplOF::hideCursor()
{
	ofHideCursor();
}

void AppImplOF::showCursor()
{
	ofShowCursor();
}

Vec2i AppImplOF::mouseLocation()
{
	return Vec2i(ofGetAppPtr()->mouseX, ofGetAppPtr()->mouseY);
}

Buffer AppImplOF::loadResource( const std::string &path )
{
	ofBuffer ofbuffer(path);
	std::cout << "loading " << path << " size "  << ofbuffer.size << endl;

	char * filebuffer = new char[ofbuffer.size];
	memcpy(filebuffer,ofbuffer.buffer,ofbuffer.size);
	Buffer buffer(filebuffer,ofbuffer.size);
	return buffer;
}

std::string AppImplOF::getAppPath()
{
	char currDir[1024];
	getcwd(currDir, 1024);
	return currDir;
}

string AppImplOF::getOpenFilePath( const string &initialPath, vector<string> extensions )
{
	//TODO: implement OF multiplatform open file dialog
	return string();
}

string AppImplOF::getSaveFilePath( const string &initialPath, vector<string> extensions )
{
	//TODO: implement OF multiplatform save file dialog
	return string();
}

} } // namespace cinder::app
